Unit DE16R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE15R_p, UTDE16_p;

procedure DE16R(F :Proc_F_DE; M :Integer; XN :Real;
                var YN :Array of Real; XK :Real; HMIN :Real;
                EPS :Real; P :Real; var H :Real;
                var Y :Array of Real; var RAB :Array of Real;
                var IERR :Integer);

implementation

procedure DE16R(F :Proc_F_DE; M :Integer; XN :Real;
                var YN :Array of Real; XK :Real; HMIN :Real;
                EPS :Real; P :Real; var H :Real;
                var Y :Array of Real; var RAB :Array of Real;
                var IERR :Integer);
var
I,JSTART,M2,M3,M4,M5,MP2 :Integer;
H1,HS,X :Real;
BUL :Boolean;
label
_10,_20,_30,_40,_50;
begin
IERR := 0;
for I:=1 to M do
 begin
  Y[I-1] := YN[I-1];
_10:
 end;
X := XN;
if ( XN =  XK ) 
 then goto _50;
MP2 := M + 2;
M2 := MP2 + M;
M3 := M2 + M;
M4 := M3 + M;
M5 := M4 + M;
H := Sign(H,XK-XN);
BUL := False;
JSTART := 0;
_20:
if ( not  BUL ) 
 then goto _30;
H := HS;
goto _50;
_30:
H1 := XK - X;
if ( Abs(H1) >  Abs(H) ) 
 then goto _40;
HS := H;
H := H1;
BUL := True;
_40:
DE15R(F,M,JSTART,HMIN,EPS,P,Y,X,H,BUL,RAB[0],RAB[1],
     RAB[MP2-1],RAB[M2-1],RAB[M3-1],RAB[M4-1],RAB[M5-1],IERR);
if ( IERR <  65 ) 
 then goto _20;
UTDE16(IERR,16);
_50:
end;

end.
